﻿
RT_Dialog = {

};


function RT_Dialog:ShowToggle( frame, isShow )
	frame = (type(frame) == "string") and _G[frame] or frame;
	if not frame then return end;
	if not frame:IsVisible() or isShow then
		frame:Show()
	else
		frame:Hide()
	end	
end


function RT_Dialog:Show( frame, type1, what, raidid, itemid, player, zone, boss )
	frame = (type(frame) == "string") and _G[frame] or frame;
	if not frame then return end;
	frame:Hide();
	if type1 then frame.type = type1 end
    if what then frame.what = what end
    if raidid then frame.raidid = raidid end
    if itemid then frame.itemid = itemid end
    if player then frame.player = player end
    if player then frame.playerid = player end
    if zone then frame.zone = zone end
    if boss then frame.boss = boss end
    frame:Show();
end


function RT_Dialog:Edit_OnShow( frame )
	if not frame then return end
	local rt = RaidTracker;
	local db, options, L = rt._db, rt._options, rt.L;

	local hTitle, hText, value;
	local item, raid;		
	raid = db.Log[frame.raidid]
	if frame.itemid then
		item = raid.Loot[frame.itemid]
	end

	if frame.type == "delete" then
		hText = "Really delete";
		if frame.what == "raid" then
			hTitle = "Delete Raid";
			hText = hText .. " raid \"|c0000ff00" .. rt:GetDisplayDate(raid.key) .. "|r\"?"
		elseif frame.what == "player" then
			hTitle = "Delete Player";
			hText = hText .. " player \"|c00ffffff" .. frame.playerid .. "|r\"?"
		elseif frame.what == "item" then
			hTitle = "Delete Item";
			hText = hText .. " \"|c" .. item.item.c .. item.item.name .. "|r\"?";
		end
	elseif frame.type == "note" then
		hTitle = "Edit Note";
		hText = "Editing note for"
		if frame.what == "raid" then
			hText = hText .. " raid \"|c0000ff00" .. rt:GetDisplayDate(raid.key) .. "|r\"";
			value = raid.note;		
		elseif frame.what == "player" then
			hText = hText .. " player \"|c00ffffff" .. frame.playerid .. "|r\"";
			value = raid.Players[frame.playerid] and raid.Players[frame.playerid].note;
		elseif frame.what == "item" then
			hText = hText .. " \"|c" .. item.item.c .. item.item.name .. "|r\"";
			value = item.note;
		end
	elseif frame.type == "time" then
		hTitle = "Edit Time";
		if frame.what == "raidend" then
			hText = "Editing End Time (server time)";
			value = rt:GetDisplayDate(raid.End or rt:GetTimestamp());
		elseif frame.what == "raidstart" then
			hText = "Editing Start Time (server time)";
			value = rt:GetDisplayDate(raid.key);
		elseif frame.what == "itemtime" then
			hText = "Editing Item Time (server time)";
			value = rt:GetDisplayDate(item.time);
		end
	elseif frame.type == "boss" then
			hTitle = "Edit Boss";
		if frame.what == "item" then
			hText = "Please select the next boss you are going to.";
			hText = "Editing boss for \"|c" .. item.item.c .. item.item.name .. "|r\"";
		    value = item.boss;
		elseif frame.what == "next" then
			hText = "Please select the next boss you are going to.";
	--	    value = item.player;
		end
	elseif frame.type == "zone" then
		hTitle = "Edit Zone";
		hText = "Editing zone for \"|c0000ff00" .. rt:GetDisplayDate(raid.key) .. "|r\"";
		value = raid.zone;
	elseif frame.type == "export" then
		hTitle = "Export String";
		hText = "Showing \"|c00ffffff"..RT_Options.desc.export[options.ExportFormat].."|r\" string for upload";
		if not raid.End then
			rt:Print("You have to end the raid before you exporting it");
			frame:Hide(); return;
		end
		value = RT_Export:GenerateRaid(raid);
	elseif frame.type == "itemcount" then
		hTitle = "Edit Count";
		hText = "Editing count on \"|c" .. item.item.c .. item.item.name .. "|r\"";
		if item.player then hText = hText .. " for \"|c00ffffff"..item.player.."|r\"" end
		value = item.item.count and item.item.count or 1;
	elseif frame.type == "itemcost" then
		hTitle = "Edit Cost";
		hText = "Editing cost of \"|c" .. item.item.c .. item.item.name .. "|r\"";
		if item.player then hText = hText .. " for \"|c00ffffff"..item.player.."|r\"" end
		value = tostring(item.costs or "");
	elseif frame.type == "looter" then
		hTitle = "Edit Looter";
		hText = "Editing looter for \"|c" .. item.item.c .. item.item.name .. "|r\"";
		value = item.player;
	elseif frame.type == "wipe" then
		hTitle = "Group Wipe";
		hText = "Is this a Wipe?";
	elseif frame.type == "join" then
		hTitle = "Join";
		hText = "Set details for a join event (server time)";
	elseif frame.type == "leave" then
		hTitle = "Leave";
		hText = "Set details for the leave event (server time)";
	end

	if frame.GetName then
		if hTitle then getglobal(frame:GetName().."HeaderTitle"):SetText(hTitle); end
		if hText then getglobal(frame:GetName().."HeaderText"):SetText(hText); end
		if getglobal(frame:GetName().."TextBox") then
			getglobal(frame:GetName().."TextBox"):SetText(value or "");
			getglobal(frame:GetName().."TextBox"):HighlightText();
		end
	end
    PlaySound("UChatScrollButton");

	rt:Debug("RT_Dialog:Edit_OnShow",frame:GetName(),frame.type,frame.what,frame.raidid,frame.itemid,hTitle,hText,value);
end


function RT_Dialog:Edit_OnSave( frame, option )
	if not frame then return end
	local rt = RaidTracker;
	local db, options, L = rt._db, rt._options, rt.L;
	rt:Debug("RT_Dialog:Edit_OnSave", frame.GetName and frame:GetName(), frame.raidid, frame.itemid, option);
	
	local value, item, raid;	
	raid = db.Log[frame.raidid]
	if frame.itemid then
		item = raid.Loot[frame.itemid]
	end
	if frame.GetName and getglobal(frame:GetName().."TextBox") then
		value = getglobal(frame:GetName().."TextBox"):GetText()
	else
		value = frame.value
	end
	if type(value)=="string" then value = strtrim(value); value = (#value > 0) and value or nil; end

	if frame.type == "note" then
		if frame.what == "raid" then
			raid.note = value;
			KA_RaidTracker_Update();
		elseif frame.what == "player" then
			if not raid.Players[frame.playerid] then
				raid.Players[frame.playerid] = {};
			end
			raid.Players[frame.playerid].note = value;
		elseif frame.what == "item" then
			item.note = value;
		end
	elseif frame.type == "time" then
		if not value or string.find(value, "^(%d+)/(%d+)/(%d+) (%d+):(%d+):(%d+)$") then
		    RaidTracker:Print("Edit Time: Invalid Time format");
		else
	  		if		frame.what == "raidend" then	raid.End = rt:GetTimestamp(value, 0); 	KA_RaidTracker_Update();
			elseif	frame.what == "raidstart" then	raid.key = rt:GetTimestamp(value, 0);	KA_RaidTracker_Update();
			elseif	frame.what == "itemtime" then	item.time = rt:GetTimestamp(value, 0);
			end
		end
	elseif frame.type == "boss" then
		if frame.what == "item" then
			item.boss = value;
		elseif frame.what == "next" then
			value = UIDropDownMenu_GetText(RT_EditBossFrameMenu)
			if value then value = strtrim(value) end
			if strlen(value) == 0 then value = nil end
			raid.bossnext = value;
		end
	elseif frame.type == "zone" then	
		if value and raid.zone ~= value then			
			if not db.Zones[value] then
				db.Zones[value] = { id=0, pid=0, rel=0, name=value };
				rt:Print("Added custom zone: \""..value.."\"");
			end
		end
		raid.zone = value;
		KA_RaidTracker_Update();
	elseif frame.type == "looter" then
	    if value then
			item.player = value;
	    end
	elseif frame.type == "itemcount" then
		value = value and tonumber(value)
		if not value or value==0 then
			rt:Print("Edit Count: Invalid value.");
		else
			item.item.count = (value > 1) and value
		end
	elseif frame.type == "itemcost" then
		if value and (not tonumber(value) or not string.find(value, "^(%d+%.?%d*)$")) then
    		rt:Print("Edit Costs: Invalid value");
		else
  			item.costs = value
  			if type(dkpp_ctra_sub) == "function" then
  				dkpp_ctra_sub(frame.raidid, frame.itemid);
			end;
		end
		if option == "bank" or option == "disenchant" then item.player = option end
	elseif frame.type == "wipe" then
        if not option then
	        rt:AddWipeDB()
        else												-- wait 10 secs on maybe, else full cooldown
			options.WipeLast = GetTime() + ((option=="maybe") and (-options.WipeCooldown + 10) or 0);
        end
	elseif frame.type == "join" or frame.type == "leave" then
		local name,note,time = RT_JoinLeaveFrameNameEB:GetText(),RT_JoinLeaveFrameNoteEB:GetText(),RT_JoinLeaveFrameTimeEB:GetText();
		if name == nil or strlen(name) == 0 then
			rt:Print("KA_RaidTracker Join/Leave: No player");
		elseif not string.find(time, "^(%d+)/(%d+)/(%d+) (%d+):(%d+):(%d+)$") then
			rt:Print("KA_RaidTracker Join/Leave: Invalid Time format");
		else
			tinsert( (frame.type == "join") and raid.Join or raid.Leave, { player = name, time = rt:GetTimestamp(time, 0) } );
			db.Online[name] = 1;
			rt:Print(name.." manual "..frame.type.." at "..time);
			if note and strlen(note) > 0 then
				if not raid.Players[name] then
					raid.Players[name] = {};
				end
				raid.Players[name].note = note;
			end
		end
	end

	frame.type = nil;
	frame.what = nil;
	frame.raidid = nil;
	frame.itemid = nil;
	frame.playerid = nil;
	frame.player = nil;			--FIXME: either use playerid consistantly or player
    frame.zone = nil;
    frame.boss = nil;
	
	KA_RaidTracker_UpdateView();	
end


function RT_Dialog:Delete_OnSave( frame )
	if not frame then return end
	local rt = RaidTracker;
	local db, options, L = rt._db, rt._options, rt.L;
	rt:Debug("RT_Dialog:Delete_OnSave", frame:GetName(), frame.raidid, option);

	local raid = db.Log[frame.raidid];
	
	if frame.type == "delete" then
		if frame.what == "raid" then
			rt:DeleteSessionDB(frame.raidid);
		elseif frame.what == "item" then
			tremove(raid.Loot, frame.itemid);
			for i,v in pairs(raid.Loot) do
				v.id = i;
			end
		elseif frame.what == "player" then
			for k, v in pairs(raid.Join) do
				if v.player == frame.playerid then
					tremove(raid.Join, k);
				end
			end
			for k, v in pairs(raid.Leave) do
				if v.player == frame.playerid then
					tremove(raid.Leave, k);
				end
			end
			if id == db.Options.CurrentRaid then
				db.Online[frame.playerid] = nil;
			end
			if raid.Players then
				raid.Players[frame.playerid] = nil;
			end
		end
	end

	frame.type = nil;
	frame.what = nil;
	frame.raidid = nil;
	frame.itemid = nil;
	frame.playerid = nil;
	frame.player = nil;			--FIXME: either use playerid consistantly or player
    frame.zone = nil;
    frame.boss = nil;

	KA_RaidTracker_Update();
	KA_RaidTracker_UpdateView();
end
